;
;	Disassembled by:
;		DASMx object code disassembler
;		(c) Copyright 1996-2003   Conquest Consultants
;		Version 1.40 (Oct 18 2003)
;
;	File:		hermes_2.bin
;
;	Size:		2048 bytes
;	Checksum:	DC2B
;	CRC-32:		5CD9BBA2
;
;	Date:		Tue Jan 14 09:20:43 2020
;
;	CPU:		Intel 8049 (MCS-48 family)
;
;       flag 0 - sound on or off
;	flag 1 - serial in use
;	R0
;	R1
;	R2 - current operating flags
;          bit 0   Hermes Extensions on  On=1/Off=0  Once set, only a reset / power off can set back to 0
;          bit 1   Sound On=1/Off=0
;          bit 2
;          bit 3   Key Click On=1/Off=0
;          bit 4   Keyboard flag?  (is this CTRL/ALT/Shift pressed flag?)
;          bit 5   This is used for something, but what exactly?
;          bit 6
;          bit 7
;
;
;	R3 - holds shift status and repeat key
;	R4 - version - set by call to IPCRAM%
;	R5 - revision - set by call to IPCRAM%
;	R6
;	R7 - status returned by IPC command 1 built at L0410 or temp storage for A
;	
;	R0' to R7' used in interrupt routines  (18-1F)
;
;	R0' used to build character received on serial port
;	R1' buffer pointer
;	R2' value used for interrupt pin routines - baud rate?
;	R3'
;	R4' state machine for timer interrupt
;	R5' holds timer value - set in interrupt routine for int pin and at startup
;	R6' used as counter for delays
;	R7' used to save A
;
;       stack is from 08-0F (4 levels - 4 pairs bytes)
;
;	RAM 10H - Ser1 baud and flags
;	RAM 11H - ??
;	RAM 12H - pointer to SER1 buffer
;	RAM 13H
;	RAM 14H - Ser2 baud and flags
;	RAM 15H - ??
;	RAM 16H - pointer ot Ser2 buffer
;	RAM 17H
;         note these are in the stack space - so the available stack is only 4 calls deep,  but I think we only get to 2 - interrupt and call
;
;	20-3F - Ser1 buffer (31 bytes)
;	60-7F - Ser2 buffer (31 bytes)
;
;	40..47	8 byte IPCOM sound parameters
;	40	pitch1
;	41	pitch2
;	42,43	step interval
;	44,45	duration
;	46	pitch/wrap
;	47	random/fuzz
;
;	4B-4F	temp sound registers
;
;	48	kbd??
;	49,4A	Random number
;	
;
;	54	shift ctrl alt status
;	57	key buffer count
;	58-5E   key buffer
;
	org	00000H
;
Reset:
	nop
	jmp	INIT_Start
;
ExtInt:
	sel	rb1
	mov	r7,a						; save A in R7'
L0005:
	jmp	Do_Int
;
TimerInt:
	sel	rb1
L0008:
	strt	t
	mov	r7,a						; save A in R7'
	mov	a,r4						; get R4' to tell us where to jump to next
	jmpp	@a						;INFO: indirect jump - table is at L0086
;
;  Timer interrupt routines are found below - from the state machine based on R4 value
;
L000C:
	inc	r5
L000D:
	inc	r4
	mov	a,r5
	mov	t,a
	mov	a,@r0
	jni	L0014
	inc	a
L0014:
	rr	a
	mov	@r0,a
	mov	a,r7
	retr
;
L0018:
	nop
	mov	r3,#000H
	mov	a,@r0
	jni	L0024
	add	a,#001H
L0020:
	rr	a
	mov	@r0,a
	jmp	L017F
L0024:
	jmp	L0020
;
L0026:
	inc	r5
L0027:
	inc	r4
L0028:
	strt	t
	mov	a,r5
	mov	t,a
	mov	a,@r0
	jni	L002F
	inc	a
L002F:
	rr	a
	mov	@r0,a
	mov	a,r7
	retr
;
L0033:
	inc	r4
	mov	a,r7
	retr
;
L0036:
	inc	r5
L0037:
	inc	r4
	mov	a,r5
	mov	t,a
	mov	a,@r0
	jni	L0048
	add	a,#001H
L003F:
	rr	a
	mov	@r0,a
	mov	a,r6
L0042:
	djnz	r6,L0042
	mov	r6,a
	mov	a,r7
	strt	t
	retr
L0048:
	jmp	L003F
;
L004A:
	inc	r5
L004B:
	inc	r4
	mov	a,r5
	mov	t,a
	mov	a,@r0
	jni	L0058
	strt	t
	add	a,#001H
L0054:
	rr	a
	mov	@r0,a
	mov	a,r7
	retr
;
L0058:
	strt	t
	jmp	L0054
;
L005B:
	call	L07A6					; calls a table lookup a L0700
L005D:
	call	L07A5					; same as above but with nop first
L005F:
	jmp	L013E
;
L0061:
	dis	tcnti
	en	i
	mov	a,r7
	inc	r4
	jni	L0068
	retr
;
L0068:
	mov	r6,#006H
	mov	a,r5
	dec	a
	mov	t,a
L006D:
	jmp	L0120
;
L006F:
	inc	r4
	mov	a,r5
	mov	t,a
	nop
	dis	tcnti
	en	i
	mov	a,r7
	jni	L006D
	retr
;
L0079:
	nop
L007A:
	jmp	L017C
;
L007C:
	inc	r4			; next call will turn speaker off
	orl	p2,#002H		; speaker on
	jmp	L0200			; sound parameter processing
;
L0081:
	dec	r4			; next call will turn speaker on
	anl	p2,#0FDH		; speaker off
	jmp	L0200			; sound parameter processing
;
L0086:
;
;  Jump table for Timer interrupt
;
;  Some kind of large state machine based on R4 value
;
	db	   07CH	
	db	   081H	
	db	   05BH	
	db	   033H	
	db	   027H	
	db	   033H
	db	   027H
	db	   033H
	db	   027H
	db	   033H
	db	   027H
	db	   033H
	db	   027H
	db	   033H
	db	   027H
	db	   033H
	db	   027H
	db	   033H
	db	   026H
	db	   033H
	db	   079H
	db	   05BH
	db	   027H
	db	   027H
	db	   027H
	db	   027H
	db	   027H
	db	   027H
	db	   027H
	db	   026H
	db	   07AH
	db	   06FH
	db	   00DH
	db	   00DH
	db	   00DH
	db	   00DH
	db	   00DH
	db	   00DH
	db	   00DH
	db	   00CH
	db	   07AH
	db	   061H
	db	   037H
	db	   037H
	db	   037H
	db	   037H
	db	   037H
	db	   037H
	db	   037H
	db	   036H
	db	   079H
	db	   05DH
	db	   04BH
	db	   04BH
	db	   04BH
	db	   04BH
	db	   04BH
	db	   04BH
	db	   04BH
	db	   04AH
	db	   07AH
	db	   05FH
	db	   037H
	db	   037H
	db	   037H
	db	   037H
	db	   037H
	db	   037H
	db	   037H
	db	   036H
	db	   07AH
	db	   027H
	db	   027H
	db	   027H
	db	   027H	
	db	   027H
	db	   027H
	db	   027H
	db	   026H
	db	   07AH
	db	   00DH
	db	   00DH
	db	   00DH
	db	   00DH
	db	   00DH
	db	   00DH
	db	   00DH
	db	   018H
;	
;	addc	a,r4
;	movx	a,@r1
;	anl	a,r3
;
;	db	033H
;;
;	clr	a
;;
;	db	033H
;;
;	clr	a
;;
;	db	033H
;;
;	clr	a
;;
;	db	033H
;;
;	clr	a
;;
;	db	033H
;;
;	clr	a
;;
;	db	033H
;;
;	clr	a
;;
;	db	033H
;;
;	clr	a
;;
;	db	033H
;;
;	jnt0	L0033
;	addc	a,r1
;	anl	a,r3
;	clr	a
;	clr	a
;	clr	a
;	clr	a
;	clr	a
;	clr	a
;	clr	a
;	jnt0	L007A
;	add	a,r7
;	movd	a,p5
;	movd	a,p5
;	movd	a,p5
;	movd	a,p5
;	movd	a,p5
;	movd	a,p5
;	movd	a,p5
;	movd	a,p4
;	addc	a,r2
;	add	a,@r1
;	cpl	a
;	cpl	a
;	cpl	a
;	cpl	a
;	cpl	a
;	cpl	a
;	cpl	a
;	jt0	L0079
;	anl	a,r5
;	orl	a,r3
;	orl	a,r3
;	orl	a,r3
;	orl	a,r3
;	orl	a,r3
;	orl	a,r3
;	orl	a,r3
;	orl	a,r2
;	addc	a,r2
;	anl	a,r7
;	cpl	a
;	cpl	a
;	cpl	a
;	cpl	a
;	cpl	a
;	cpl	a
;	cpl	a
;	jt0	L007A
;	clr	a
;	clr	a
;	clr	a
;	clr	a
;	clr	a
;	clr	a
;	clr	a
;	jnt0	L007A
;	movd	a,p5
;	movd	a,p5
;	movd	a,p5
;	movd	a,p5
;	movd	a,p5
;	movd	a,p5
;	movd	a,p5
;	inc	r0
;
;
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
;
;
L0100:
; jump table for interrupt routine at entered L0111 - jumps on value in r2 (2nd bank) baudrate
;
;
	db	014H			;  0
	db	028H			;  1
	db	032H			;  2
	db	04CH			;  3
	db	055H			;  4
	db	062H			;  5
	db	06AH			;  6
	db	072H			;  7
	db	014H			;  8
	db	028H			;  9
	db	032H			;  A
	db	04CH			;  B
	db	055H			;  C
	db	062H			;  D
	db	06AH			;  E
	db	072H			;  F
	db	025H			;  10   - disables interrupts and restores A
;
;	call	L0028
;	jb1	L014C
;	strt	t
;	mov	t,a
;	add	a,r2
;	jb3	L0114
;	xch	a,r0
;	jb1	L014C
;	strt	t
;	mov	t,a
;	add	a,r2
;	jb3	L0125
;
Do_Int:
	mov	a,r2						; this is R2 in 2nd bank - it's set after L0753 with baud rate from 10H or 14H
	strt	t
	jmpp	@a						;INFO: indirect jump - table is at L0100
;
L0114:						; get here if R2' is 0 or 8 - baud 19200
	movp	a,@a				; seems odd as it just puts the value of the jump address in a, but then overwrites below
	nop
	mov	r4,#0D6H
	mov	r5,#0FFH
	mov	a,r7				; restore a from R7'
L011B:
	jni	L011E				; interupt?
	retr					; return if not
;
L011E:
	mov	a,r5
	mov	t,a				; load the timer from r5 value
L0120:
	mov	a,@r1
	mov	r0,a
	mov	@r0,#000H
	en	tcnti				; enable timer
L0125:						; get here if R2' is 10 (Dec 16) - think this means serial off
	dis	i
	mov	a,r7				; restore a from R7'
	retr
;
L0128:						; get here if R2' is 1 or 9 - baud 9600
;
	call	L079F				; calls 2 cascaded lookups from table at L0700 - delay?
	mov	r4,#0CDH
	mov	r5,#0FEH
	strt	t
	mov	a,r7				; restore a from R7'				
	jmp	L011B
;
L0132:						; get here if R2' is 2 or A - baud 4800
;
	mov	r4,#0C3H
	mov	r5,#0FCH
	mov	a,#0FFH
L0138:
	strt	t
	dis	i
	mov	t,a				; load timer
	mov	a,r7				; restore a from R7'
	en	tcnti				; enable it
	retr
;
L013E:
	mov	a,r5
	dec	a
	mov	t,a
	call	L07A5				; calls a nop then table lookup at L0700
	mov	r6,#001H
	inc	r4
	dis	tcnti
	en	i
	mov	a,r7				; restore a from R7'
	jni	L0120
	retr
;
L014C:						; get here if R2' is 3 or B - baud 2400
	mov	r4,#0B9H
	mov	r5,#0F7H
	mov	a,#0FDH
	nop
	jmp	L0168
;
L0155:						; get here if R2' is 4 or C  - baud 1200
;
	mov	r4,#0AFH
	mov	r5,#0EEH
	mov	a,#0F8H
	mov	r6,#007H
	nop
L015E:
	djnz	r6,L015E			; delay a bit
	jmp	L0138
;
L0162:						; get here if R2' is 5 or D - baud 600
;
	mov	r4,#0A5H
	mov	r5,#0DAH
	mov	a,#0EEH
L0168:
	jmp	L0138
;
L016A:						; get here if R2' is 6 or E - baud 300
;
	mov	r4,#09BH
	mov	r5,#0B4H
	mov	a,#0DCH
	jmp	L0178
;
L0172:						; get here if R2' is 7 or F - baud 75
;
	mov	r4,#088H
	mov	r5,#0CFH
	mov	a,#069H
L0178:
	mov	r6,#002H
	jmp	L015E
;
; that seems to be the end of processing for the INT handler, following routines are carried over from first page - timer interrupts
;
;
L017C:
	movp	a,@a
	mov	r3,#000H
L017F:
	dis	tcnti
	en	i
	mov	a,r0
	add	a,#0E1H
	orl	a,#020H
	mov	@r1,a
	dec	r1
	add	a,@r1
	inc	r1
	jz	L01A5
	anl	a,#01FH
	add	a,#0E5H
	jnz	L019C
	orl	p2,#030H		; CTR / DTS high
	clr	f1
L0195:
	call	L07A6					; calls table lookup at L0700
L0197:
	nop
	mov	a,r7
	jni	L01AE
	retr
;
L019C:
	mov	r0,#050H
	mov	a,@r0
	swap	a
	inc	a
	swap	a
	mov	@r0,a
	jmp	L0197
;
L01A5:
	rrc	a
	inc	r1
	orl	a,@r1
	mov	@r1,a
	dec	r1
	mov	a,r0
	mov	@r1,a
	jmp	L0195
;
L01AE:
	orl	p2,#030H		; CTR / DTS high
	clr	f1
	inc	r1
	mov	a,#040H
	orl	a,@r1
	mov	@r1,a
	dec	r1
	mov	a,r7
	retr
;
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
;
;  Sound routines - lets make some noise...
;
L0200:
	mov	r1,#044H				; get duration - 2 bytes
	mov	a,@r1
	inc	r1
	jnz	L0209
	mov	a,@r1
	jz	L020D
L0209:
	call	L0311
	jz	L0278
L020D:
	mov	r1,#04CH
	call	L0311
	jnz	L025F
	inc	r1
	mov	r0,#046H				; pitch/wrap
	mov	a,@r0
	swap	a
	orl	a,#0F0H
	jb3	L021E
	anl	a,#00FH
L021E:
	add	a,@r1
	mov	@r1,a
	mov	r0,#040H				; pitch1
	mov	a,@r0
	cpl	a
	add	a,@r1
	jnc	L022D
	inc	r0
	mov	a,@r1					; pitch2
	cpl	a
	add	a,@r0
	jc	L024E
L022D:
	mov	r0,#046H				; pitch/wrap
	mov	a,@r0
	orl	a,#0F0H
	cpl	a
	inc	r3
	jz	L0244
	orl	a,#0F0H
	add	a,r3
	jnz	L0244
	mov	r3,a
	mov	a,@r0
	xrl	a,#0F0H
	add	a,#010H
	mov	@r0,a
	jmp	L024E
;
L0244:
	mov	r1,#041H
L0246:
	mov	a,@r0
	jb7	L024A
	dec	r1
L024A:
	mov	a,@r1
	mov	r0,#04DH
	mov	@r0,a
L024E:
	mov	r0,#042H				; step
	mov	r1,#04BH
	mov	a,@r0
	mov	@r1,a
	inc	r0
	inc	r1
	mov	a,@r0
	mov	@r1,a
	mov	r0,#047H			; random / fuzz
	mov	a,@r0
	swap	a
	inc	r1
	call	L031F
L025F:
	mov	r1,#047H			; random / fuzz
	mov	a,@r1
	mov	r1,#04EH
	call	L031F
	mov	a,@r1
	add	a,#009H
	cpl	a
	jnc	L026D
	clr	a
L026D:
	mov	r5,a
	mov	a,t
	add	a,r5
	mov	t,a
	mov	a,r7
	retr
;
L0273:
	sel	rb1
	mov	a,r1				; get R1'
	cpl	a				; invert it
	jb6	L027D				; effectively jump if bit 6 was off in R1'
L0278:
	dis	tcnti
	anl	p2,#0FDH			; turn off bit 1 - speaker 
	mov	r1,#000H			; R1' to 0
L027D:
	mov	a,r7				; get R7' in A
	retr
;
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
L0300:
;
; Look up table for keyrow - value 000 to 111 translated to a row address for output
;
;
	db	001H
	db	002H
	db	004H
	db	008H
	db	010H
	db	020H
	db	040H
	db	080H
;
;	db	001H
;
;	outl	bus,a
;	jmp	L0008
;
;	inc	@r0
;	xch	a,@r0
;	orl	a,@r0
;	movx	a,@r0
;
Reset_state_mc:
	sel	rb1
	mov	r2,#010H				; reset interrupt state machine
	dis	tcnti					; disable timer interrupt
	dis	i					; disable interrupt
	clr	a
	mov	r1,a					; reset r1'
	clr	f1					; no serial running
	retr
;
L0311:
	mov	a,r5
	dec	r1
	add	a,@r1
	mov	@r1,a
	inc	r1
	jc	L031D
	xch	a,@r1
	jz	L031E
	dec	a
	xch	a,@r1
L031D:
	orl	a,@r1
L031E:
	ret
;
L031F:
	jb3	L0325
	mov	a,@r1
	inc	r1
	mov	@r1,a
	ret
;
L0325:
	anl	a,#007H
	movp3	a,@a
	mov	r6,a
	add	a,r6
	dec	a
	mov	r0,#04AH
	anl	a,@r0
	xch	a,r6
	cpl	a
	inc	a
	add	a,r6
	add	a,@r1
	inc	r1
	mov	@r1,a
L0335:
	mov	r0,#049H
	mov	a,r0
	add	a,@r0
	mov	@r0,a
	inc	r0
	addc	a,@r0
	mov	@r0,a
	ret
;
; get 8 bits?
;
IPC_Get_8:
	mov	r6,#001H
	jmp	L0345
;
; get 4 bits?
;
IPC_Get_4:
	mov	a,#010H
L0344:
	mov	r6,a
L0345:
	in	a,p2
	jb7	L0345
	movx	@r0,a
	in	a,p2
	movx	@r0,a
	rlc	a
	mov	a,r6
	rlc	a
	jnc	L0344
	ret
;
; Send 8 bits
;
IPC_Send_8:
	mov	r5,#008H
	jmp	L0358
;
; Send 4 bits
;
IPC_Send_4:
	swap	a
	mov	r5,#004H
L0358:
	rl	a
	mov	r6,a
	jb0	L0369
L035C:
	in	a,p2
	jb7	L035C
	movx	@r0,a
	anl	p2,#07FH
	movx	@r0,a
	orl	p2,#080H
	mov	a,r6
	djnz	r5,L0358
	ret
;
L0369:
	in	a,p2
	jb7	L0369
	movx	@r0,a
	orl	p2,#080H
	movx	@r0,a
	mov	a,r6
	djnz	r5,L0358
	ret
;
Set_Baud:
	mov	a,@r1
	jb6	L0387			; I think this checks to see if specific baud rate is on (overide by rxbaud%)
	mov	a,r7
	xchd	a,@r1
L0379:
	sel	rb1
	mov	a,r1
	sel	rb0
	add	a,#0FEH
	xrl	a,r1
	jnz	L0387
	mov	a,@r1
	anl	a,#00FH
	sel	rb1
	mov	r2,a
	sel	rb0
L0387:
	ret
;
;   Function to do (mem) + (mem-1) / and return lowest 5 bits in a  where mem is pointed to by R0
;    used to get data remaining in buffer
;
L0388:
	mov	a,@r1
	dec	r1
	add	a,@r1
	anl	a,#01FH
	ret
;
; This looks like where re read a keyboard row and save it in R6
;
Read_Kbd_bus:
	ins	a,bus
	xch	a,r6
;
; This is called first from L0609 to set row
;
Set_kbd_row:
	outl	p1,a
	rr	a
	xch	a,r6		; save 'next' row in R6
	ret
;
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
;
L03E0 - jump table for movp3 instructon at ??
;
	db	000H
	db	000H
	db	001H
	db	008H
	db	002H
	db	008H
	db	008H
	db	008H
	db	003H
	db	008H
	db	008H
	db	008H
	db	008H
	db	008H
	db	008H
	db	008H

;	nop
;	nop
;
;	db	001H
;
;	ins	a,bus
;	outl	bus,a
;	ins	a,bus
;	ins	a,bus
;	ins	a,bus
;	add	a,#008H
;	ins	a,bus
;	ins	a,bus
;	ins	a,bus
;	ins	a,bus
;	ins	a,bus
;	ins	a,bus
;
; data table for movp3 instruction after L0669:
;
L03F0:
	db	0E0H		; 0 col 3 key pressed
	db	004H		; 1 col 4 key pressed
	db	005H		; 2 col 5 key pressed
	db	008H		; 3 invalid
	db	006H		; 4 col 6 key pressed
	db	008H		; 5 invalid
	db	008H		; 6 invalid
	db	008H		; 7 invalid
	db	007H		; 8 col 7 key pressed
	db	008H		; 9+ invalid ...
	db	008H
	db	008H
	db	008H
	db	008H
	db	008H
	db	008H

;	db	0E0H
;
;	jmp	L0005
;
;	ins	a,bus
;
;	db	006H
;;
;	ins	a,bus
;	ins	a,bus
;	ins	a,bus
;	dec	a
;	ins	a,bus
;	ins	a,bus
;	ins	a,bus
;	ins	a,bus
;	ins	a,bus
;	ins	a,bus
;	ins	a,bus
;
L0400:
;
; IPC commands jump table
;
;
	db	055H			;     0: init IPC
	db	057H			;     1: get interrupt status
	db	05CH			;     2: open ser1
	db	060H			;     3: open ser2
	db	068H			;     4: close ser1
	db	06CH			;     5: close ser2
	db	0DCH			;     6: serial1 receive
	db	0E0H			;     7: serial2 receive
	db	07EH			;     8: read keyboard
	db	08FH			;     9: keyrow
	db	09CH			;     a: set sound
	db	0AEH			;     b: kill sound
	db	0B5H			;     c: New IPC Commands
	db	0B7H			;     d: set serial baudrate
	db	0C7H			;     e: get random 
	db	0D1H			;     f: test
;
;
;
;	strt	t
;	da	a
;	anl	a,r4
;	add	a,@r0
;	add	a,r0
;	add	a,r4
;	xrl	a,r4
;
;	db	0E0H
;
;	addc	a,r6
;	orld	p7,a
;	anld	p4,a
;	mov	r6,a
;	cpl	f1
;
;	db	0B7H
;
;	mov	a,psw
;	xrl	a,@r1
;
;
;   entry point after scanning keyboard and optionally processing serial / sound at L0710
;    r7 will be used to build the state of the IPC input - read using IPC command 1
;
;	* returns a byte, the bits of which are:
;	ipc..kb equ     0       set if data available in keyboard buffer, or key held
;	ipc..so equ     1       set if sound is still being generated
;	*               2       set if kbd shift setting has changed, with key held
;	*               3       set if key held down
;	ipc..s1 equ     4       set if input is pending from RS232 channel 1
;	ipc..s2 equ     5       set if input is pending from RS232 channel 2
;	ipc..wp equ     6       return state of p26, currently not connected
;	*               7       was set if serial transfer was being zapped, now zero
;
Get_IPC_Stat_R7:
	in	a,p2
	anl	a,#040H			; check p2.6 - this gets bit 6 of the IPC Status
	orl	a,r3			; merge r3 - key held and shift setting changed
	jb3	L0420			; key held down?
	mov	r7,a			; save a
	mov	r1,#057H
	mov	a,@r1
	anl	a,#007H
	jnz	L041F
	dec	r7			; this will make r7 FF
L041F:
	mov	a,r7			; 
L0420:
	jf0	L0424			; making sound?
	anl	a,#0FDH			; no - so turn off bit 1
L0424:
	mov	r7,a			; store it
	mov	r1,#010H		; serial 1?
	mov	a,@r1
	jb7	L0430			; no, so jump to next query
	inc	r1			; get pointers
	mov	a,@r1
	inc	r1
	add	a,@r1
	jnz	L0434			; is there data in ser1 buffer?
L0430:
	mov	a,#0EFH			; there is no data 
	anl	a,r7			; turn off bit 4
	mov	r7,a			; and save it
L0434:
	mov	r1,#014H		; serial 2?
	mov	a,@r1
	jb7	L043F			; no, so jump to next
	inc	r1
	mov	a,@r1
	inc	r1
	add	a,@r1
	jnz	L0443			; is there any data in ser2 buffer?
L043F:
	mov	a,#0DFH			; there is no data
	anl	a,r7			; turn off bit 5
	mov	r7,a			; and save it
L0443:
	mov	r0,#050H
	in	a,p2
	jb7	L044B					; IPC Command ?
	call	IPC_Get_4
	jmpp	@a					;INFO: indirect jump - table is at L0400
;
L044B:
	clr	a					; no IPC command
	xchd	a,@r0
	jz	L0453					; if @r0 is non zero bounce commdata
	anl	p2,#07FH				; force commdata low/high
	orl	p2,#080H
L0453:
	jmp	Scan_KBD
L0455:
;
; IPC COMMAND 0 (reset IPC)
;
	jmp	L05BE
;
L0457:
;
; IPC COMMAND 1 (get ipcom status)
;

	mov	a,r7
IPC_Ret_1:
	call	IPC_Send_8
	jmp	Scan_KBD
;
; IPC COMMAND 2 (Open SER1)
;

	mov	r1,#010H
	jmp	L0462
;
; IPC COMMAND 3 (Open SER2)
;

	mov	r1,#014H
L0462:
	mov	a,#07FH
	anl	a,@r1			; turn off bit 7
L0465:
	mov	@r1,a
	jmp	Scan_KBD
;
; IPC COMMAND 4 (Close SER1)
;

	mov	r1,#012H
	jmp	L046E
;
; IPC COMMAND 5 (Close SER2)
;

	mov	r1,#016H
L046E:
	sel	rb1
	mov	a,r1
	sel	rb0
	xrl	a,r1
	dec	r1
	dec	r1
	jnz	L0479
	orl	p2,#030H		; make dtr / cts high
	clr	f1			; not doing serial
L0479:
	mov	a,#080H
	orl	a,@r1			; turn on bit 7
	jmp	L0465
;
; IPC COMMAND 8 (Read Keyboard)
;
	mov	r1,#057H		; number key press pairs
	clr	a
	xchd	a,@r1			; get lowest 4 bits
	mov	r7,a			; save it
	mov	a,#008H			; mask for msb of 4 bit nibble
	anl	a,r3			; get last key pressed still bit flag
	orl	a,r7			; and number of keys in buffer
	call	IPC_Send_4		; send the first nibble
	inc	r1			; keyboard buffer?
	clr	a
	xch	a,@r1
	inc	r7			; bump number of keys to get counter
	jmp	L0533			; go process remaining keys
;
; IPC COMMAND 9 (Keyrow)
;
	call	IPC_Get_4
	anl	a,#007H			; mask off lower 3 bits  (8 key rows)
	movp3	a,@a			; get row address for output  (table at L0300)
	call	Set_kbd_row
	call	L07A7			; just calls a ret instruction - a delay?
	call	Read_Kbd_bus
	jmp	IPC_Ret_1
;
; IPC COMMAND A (Set Sound)
;
	call	L0273
	mov	r0,#040H		; start of 8 bytes sound parameters
	mov	r7,#008H		; we want to collect 8 bytes
L04A2:
	call	IPC_Get_8
	mov	@r0,a
	inc	r0
	djnz	r7,L04A2
	clr	f0
	cpl	f0			; set flag 0 to say we are making noise
	mov	a,#002H
	jmp	L0577			; exit via keyclick on/off code
;
; IPC COMMAND B (Kill Sound)
;
	call	L0273
	clr	f0
	mov	a,#0FDH
	jmp	L057D
;
; IPC COMMAND C (New IPC Commands)
;
	jmp	L054B
;
; IPC COMMAND D (Set Baud Rate (default if not using rxbaud%?))
;
	call	IPC_Get_4
	anl	a,#007H				; only lowest 3 bits relevant
	mov	r7,a				; save in R7
	mov	r1,#010H			; ser1
	call	Set_Baud
	mov	a,r7
	mov	r1,#014H			; ser2
	call	Set_Baud
	jmp	Scan_KBD
;
; IPC COMMAND E (Get Random)
;
	call	L0335
	dec	r0
	mov	a,@r0
	call	IPC_Send_8
	inc	r0
	mov	a,@r0
	jmp	IPC_Ret_1
;
; IPC COMMAND F (Test)
;
	call	IPC_Get_8				       ; get a byte from Zx8302
	mov	r7,a					       ; save it
	mov	a,r2					       ; R2 to see if we are switched on
	cpl	a
	jb0	L0457					       ; via IPCCMD 1 if HERMES is off
	mov	a,r7					       ;
	cpl	a					       ; or send the complement if we are on.
	jmp	IPC_Ret_1
;
; IPC COMMAND 6 (Read SER1)
;
	mov	r1,#013H
	jmp	L04E2
;
; IPC COMMAND 7 (Read SER2)
;
	mov	r1,#017H
L04E2:
	inc	@r0
	mov	a,r1
	mov	r0,a
	clr	a
	xch	a,@r0
	mov	r7,a
	dec	r1
	call	L0388
	add	a,#0E7H
	jnc	L04F0
	clr	a
L04F0:
	add	a,#019H
	xch	a,r7
	orl	a,@r0
	anl	a,#0C0H
	orl	a,r7
	inc	r7
	jmp	L0545
;
	nop
	nop
	nop
	nop
	nop
	nop
;
;
L0500:
;
; New IPC commands jump table
;
;
	db	05DH			;     0: set P23 Low (INT 2 normally)
	db	061H			;     1: set P23 High 
	db	065H			;     2: set P20 Low (normally serial input)
	db	069H			;     3: set P20 High
	db	06DH			;     4: set P26 Low 
	db	071H			;     5: set P26 High
	db	075H			;     6: KeyClicks Off
	db	07BH			;     7: KeyClicks On
	db	080H			;     8: Enable clock on T0
	db	055H			;     9: Turn on Hermes
	db	083H			;     a: IPSIG% command
	db	092H			;     b: IPCRAM%
	db	092H			;     c: Reserved (SuperHermes)
	db	09CH			;     d: RXBAUD%
	db	05DH			;     e: As command 0 
	db	061H			;     f: As command 1
;
;
;	anl	a,r5
;	add	a,@r1
;	stop	tcnt
;	add	a,r1
;	add	a,r5
;	addc	a,@r1
;	ent0	clk
;	addc	a,r3
;	movx	a,@r0
;	strt	t
;	ret
;
;	jb4	L0592
;	anld	p4,a
;	anl	a,r5
;	add	a,@r1
;
L0510:
;
;  Init table for RAM locations 10H-16H  (16-22) - set in INIT_Start at L05C8:
;
;         16: ser1 input port baud rate and flags
;	  20: ser2 input port baud rate and flags
;RXBAUD%
;
;This is a function to read and set the serial port input rates.
;
;Syntax:  RXBAUD%(parameter%)
;
;parameter% gives the port and the value to send.
;
;The result is the old value, including whether the port is open or not.
;
;The value consists of the following:
;
;bit 7        : Send  0=ser1, 1=ser2.  Return 0=open or 1=closed. (code
;               128)
;bit 6        : Set if BAUD command is not to affect this input port.
;               (code 64)
;bits 3 to 0  : Standard baud rates (bit 4 ignored at present)
;               codes 0-7 = 19200, 9600, 4800, 2400, 1200, 600, 300, 75
;               codes 8-15 duplicate the above, at present, but will be
;               used for additional baud rates, e.g. RTTY speeds.
;All other bits are reserved and must be zero.
;
;
	db	081H	; Ser1 Closed, 9600 BAUD - loc 10H
	db	0E0H	; 11H - ??
	db	020H	; 12H - buffer pointer for Ser1 queue
	db	000H	; 13H
	db	081H	; Ser2 Closed, 9600 BAUD - loc 14H
	db	0A0H	; 15H - ??
	db	060H	; 16H - buffer pinter for ser2 queue
;
;	movx	a,@r1
;
;	db	0E0H
;
;	xch	a,@r0
;	nop
;	movx	a,@r1
;	mov	@r0,a
;	add	a,@r0
;
;
;
;  Following code reads the kbd buffer until it's empty
;
L0517:
	inc	r1
	clr	c
	rrc	a				; top bit is cleared. bottom bit saved in carry
	mov	r4,a				; save it in R4
	jz	L0525
	mov	a,r7
	dec	a
	jnz	L0525				; last one in the buffer?
	mov	a,@r1				; gets next entry in buffer
	orl	a,r4
	jmp	L0528
;
L0525:
	mov	a,@r1
	anl	a,#0FEH
L0528:
	rlc	a
	rl	a
	rlc	a
	call	IPC_Send_4
	mov	a,@r1
	anl	a,#03FH				; mask off the lowest 6 bits - we send 00 col row
	call	IPC_Send_8
	mov	a,r4
L0533:
	djnz	r7,L0517
	jmp	Scan_KBD
;
;  The code below is buffer reader - entry point is L0545 - called from IPCOM serial reader
;
L0537:
	mov	a,@r1
	cpl	a
	inc	a
	mov	r0,a
	mov	a,@r0
	xch	a,r0
	add	a,#0E1H
	orl	a,#020H
	cpl	a
	inc	a
	mov	@r1,a
	mov	a,r0
L0545:
	call	IPC_Send_8
	djnz	r7,L0537				; more characters in the buffer
	jmp	Scan_KBD
;
; Entry point for new IPC Commands (IPCEXT)
;
L054B:
	mov	a,r2					; check if Hermes is on
	jb0	L0557					; R2 bit 0 is on so get IPCEXT command
	call	IPC_Get_4
;
; IPC New Command 9 - Turn on Hermes
;
	add	a,#0F7H
	jnz	L055A
	inc	r2
	jmp	Get_IPC_Stat_R7
;
L0557:
	call	IPC_Get_4				; get IPC new command
	jmpp	@a					;INFO: indirect jump- table is at L0500
;
L055A:
	rrc	a
	jnc	L0561
;
; IPCEXT 0 and E - p23 low
;
	anl	p2,#0F7H
	jmp	Scan_KBD
;
; IPCEXT 1 and F - p23 high
;
L0561:
	orl	p2,#008H
	jmp	Scan_KBD
;
; IPCEXT 2 - p20 low
;
	anl	p2,#0FEH
	jmp	Scan_KBD
;
; IPCEXT 3 - p20 high
;
	orl	p2,#001H
	jmp	Scan_KBD
;
; IPCEXT 4 - p26 low
;
;
	anl	p2,#0BFH
	jmp	Scan_KBD
;
; IPCEXT 5 - p26 high
;
	orl	p2,#040H
	jmp	Scan_KBD
;
; IPCEXT 6 - key click off
;
	mov	a,#008H				; R2 bit 3 on
L0577:
	orl	a,r2
L0578:
	mov	r2,a
	jmp	Scan_KBD
;
; IPCEXT 7 - key click on
;
	mov	a,#0F7H				; R2 bit 3 off
L057D:
	anl	a,r2
	jmp	L0578
;
; IPCEXT 8 - enable clock output on t0
;
;
	ent0	clk
	jmp	Scan_KBD
;
; IPCEXT A (IPCSIG%)
;
	in	a,p2
	orl	a,#006H
	jt1	L058A
	anl	a,#00DH
L058A:
	jt0	L058E
	anl	a,#00BH
L058E:
	call	IPC_Send_4
	jmp	Scan_KBD
;
; IPCEXT B (IPCRAM%)
;
L0592:
	call	IPC_Get_8
	mov	r4,#002H			; IPC Version and subversion in R4 / R5
	mov	r5,#014H
	mov	r0,a
	mov	a,@r0
	jmp	IPC_Ret_1
;
; IPCEXT D (RXBAUD%)
;
	call	IPC_Get_8
	mov	r1,#014H			; assume ser2 to start with
	jb7	L05A4				; bit 7 recvd by IPC 0=ser1, 1=ser2. 
	mov	r1,#010H			; no it was ser1
L05A4:
	orl	a,#080H
	xch	a,@r1
	jb7	L05AD
	xch	a,@r1
	anl	a,#07FH
	xch	a,@r1
L05AD:
	mov	r7,a				; puts a in R7, and returns via IPCOM 1
	call	L0379				; entry point in set baud
	jmp	L0457
;
;
;
L05B2:
;
;  This is the CTRL - ALT - ESC - 7   (formerly CTRL - ALT - 7)
;
	call	Reset_state_mc
	mov	r1,a			;sets up a big delay before 'reset'
	mov	a,#0F9H			; IPL 0-2 (5) Low and speaker low
	outl	p2,a
L05B8:
	mov	r0,#000H
L05BA:
	djnz	r0,L05BA
	djnz	r1,L05B8
L05BE:
	call	Reset_state_mc			; we got here from IPC command 0, or fell through from above
	mov	psw,a			; reset the IPC by falling through here ?
;
INIT_Start:
;
;
;000E: 8A 01   ORL  P2,#01     p2.0=H,RXDin&TXDin
;0010: 9A FD   ANL  P2,#FD     p2.1=L,speaker
;0012: 8A 04   ORL  P2,#04     p2.2=H,ipl0-2
;0014: 8A 08   ORL  P2,#08     p2.3=H,ipl1
;0016: 8A 10   ORL  P2,#10     p2.4=H,CTSout
;0018: 8A 20   ORL  P2,#20     p2.5=H,DTRout
;001A: 8A 40   ORL  P2,#40     p2.6=H,??
;001C: 8A 80   ORL  P2,#80     p2.7=H,comdata
; - set P2 to FD which equates to the above command block from original IPC code!!
;
; interrupts are off when we start here, so let's set P2 port up, clear some memory, set initial regs and wait for commands
;
	mov	a,#0FDH
	outl	p2,a
	strt	t			; not sure why we start the timer here - but it will be a long time before first interrupt
	mov	r0,#05FH		; starting at this location in RAM
	clr	a			; clear A
L05C8:
	mov	@r0,a			; push A to RAM to
	djnz	r0,L05C8		; clear down memory
	mov	r1,#010H		; set R1 to 10H
	mov	r7,#007H		; for a count of 7
L05CF:
	mov	a,r1			; load from 0510H
	movp	a,@a
	mov	@r1,a			; into RAM location 10H
	inc	r1			; and repeat for the remaining 6 locations
	djnz	r7,L05CF
L05D5:
;
;     r3 flags are set to suggest data is available in buffers - this gets fixed after keyboard scan happens
;
	in	a,p2			; check COMDATA
	cpl	a			; invert for bit jump test
	jb7	L05D5			; Loop around and wait for a IPC Command
	mov	r3,#033H		; We got IPC comms so setup and go read it. 
	jmp	Scan_KBD		; via keyboard scan
;
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
L0600:
;
; - possible data table - looks like it coverts row scan address to a 3 bit value for scan code - L0693
;
	db	000H		; 00000000
	db	038H		; 00111000
	db	030H		; 00110000
	db	028H            ; 00101000
	db	020H		; 00100000
	db	018H		; 00011000
	db	010H		; 00010000
	db	008H		; 00001000
	db	000H		; 00000000
;
;	nop
;
;	db	038H
;
;	xchd	a,@r0
;	xch	a,r0
;	xch	a,@r0
;	inc	r0
;	inc	@r0
;	ins	a,bus
;	nop
;
Scan_KBD:
	mov	a,#080H			;scan ctl/alt/sh keyrow
	call	Set_kbd_row
	mov	a,#010H
	xrl	a,r2			; check flags - bit 4?
	jb4	L0615
	mov	r2,a
	anl	p2,#0FDH		; speaker off
L0615:
	mov	r0,#048H		; keyboard buffer / counter?
	inc	@r0
	mov	r5,#008H		; 8 rows to read
	mov	r7,#0F8H		; mask
	call	Read_Kbd_bus		; read the keys
	xch	a,r7			; save a (swap with mask)
	anl	a,r7			; top 5bits only
	xch	a,r7			; swap it back - now, so top 5 bits in R7
	xrl	a,r7			; use top 5 bits to mask off in original A, leaving just lowest 3 bits
	mov	r1,#057H
	mov	r0,#054H		; sca status
	xchd	a,@r0			; swap SCA bits to 54H
	xrl	a,@r0			; test to see if old value same as current
	anl	a,#007H			; mask 3 bits
	jnz	L065B			; something changed from stored SCA status
	xch	a,r7			; get back the top 5 bits for this keyrow, and save sca status
	jmp	L0669			; process them
;
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
;
L0638:
;
;  This table seems to handle the '4th' key when CTRL ALT ESC is pressed - the last 2 are 4 and 7 keyrow 0
;
	db	046H			; F4
	db	046H			; F1
	db	046H			; 5
	db	046H			; F2
	db	046H			; F3
	db	046H			; F5
	db	042H			; 4
	db	040H			; 7
;
;	jnt1	L0646
;	jnt1	L0646
;	jnt1	L0646
;	mov	a,t
;	orl	a,@r0
;
;
L0640:
	jmp	L05B2			; back to init start after delay (ctrl alt esc 7)
;
L0642:
	mov	a,#008H			; toggle bit 3 of R2   (ctrl alt esc 4)
	xrl	a,r2
	mov	r2,a
L0646:
	mov	a,#004H				; turn on bit 2
	orl	a,r3
	anl	a,#0F7H				; and off bit 3
	mov	r3,a				; store back in R3
	jmp	L0710
;
L064E:
	add	a,#0CDH
	jnz	L0661
L0652:
	mov	a,@r0
	orl	a,#0F9H
	cpl	a
	jnz	L0661
	mov	a,r7
	jmpp	@a						;INFO: indirect jump 0 using table at L0638 ?
;
L065A:
	clr	a
L065B:
	xchd	a,@r1
	mov	@r1,a
	jmp	Get_IPC_Stat_R7
;
L065F:
	call	Read_Kbd_bus
L0661:
	mov	r7,#000H
	djnz	r5,L065F		; read remaining rows...
	jmp	L069B
;
L0667:
	call	Read_Kbd_bus
L0669:
	jz	L0699			; No key pressed this row?
	mov	r4,a			; save a in R4
	swap	a			; align bottom bits for this table lookup
	orl	a,#0F0H			; mask top bits on - so following read will be from 03F0-03FF
	movp3	a,@a			; get value from lookup table
	jb7	L068E			; E0 - no key pressed in upper 4 keys, so it was col 3
	jb3	L0661			; 08 - key combo not applicable
	xch	a,r4			; restore a, R4 now holds cols 4-7
	anl	a,#00FH		 	; mask effectively checks for key in column 4
	jz	L0693			; not one
	add	a,#0F8H
	jnz	L0661
	mov	a,r5
	add	a,#0FEH
	jnz	L0661
	mov	a,#038H
	add	a,r4
	xch	a,r7
	jnz	L0661
	call	Read_Kbd_bus
	jz	L0652
	jmp	L0661
;
L068E:
	orl	a,r4				; seems to use table at L03E0
	movp3	a,@a				; for look up - getting col into R4
	jb3	L0661
	mov	r4,a
L0693:
	mov	a,r5				; take row address
	movp	a,@a				; convert to 3 bit value for bits 5-3 of scancode
	orl	a,r4				; or it with r4 - must have column value
	xch	a,r7				; save in r7
	jnz	L064E
L0699:
	djnz	r5,L0667			; read next row
L069B:
	mov	a,r7
	dec	r1
	xch	a,@r1
	xrl	a,@r1
	inc	r1
	jnz	L065A
	mov	a,@r1
	add	a,#010H
	mov	@r1,a
	jnc	L06C6
	mov	a,@r0
	mov	r6,a
	swap	a
	mov	@r0,a
	inc	r0
	mov	a,r7
	jnz	L06B7
	mov	@r0,a
L06B1:
	mov	a,#0F3H
	anl	a,r3
	mov	r3,a
	jmp	L0710
;
L06B7:
	xch	a,@r0
	xrl	a,@r0
	jnz	L06CE
	mov	a,r6
	swap	a
	xrl	a,r6
	jnz	L0646
	mov	a,r3
	jb2	L06C6				; shift key setting changed
	orl	a,#008H				; key held down
	mov	r3,a
L06C6:
	jmp	L0710
;
L06C8:
	inc	r1
	swap	a
	orl	a,@r1
	mov	@r1,a
	jmp	L0646
;
L06CE:
	mov	a,r6
	rrc	a
	rr	a
	rr	a
	anl	a,#0C0H
	orl	a,r7
	mov	r0,a
	mov	a,@r1
	inc	a
	jb3	L06C8
	inc	@r1
	inc	r1
	jnc	L06E4
	mov	r5,a
	movp3	a,@a
	rr	a
	orl	a,@r1
	mov	@r1,a
	mov	a,r5
L06E4:
	orl	a,r1
	xch	a,r0
	mov	@r0,a
	mov	a,r2
	jb3	L06EF
	orl	a,#010H
	mov	r2,a
	orl	p2,#002H			; speaker on
L06EF:
	mov	r0,#048H			; looks like this lot is used to seed random number
	mov	a,@r0
	inc	r0				; random number byte 1
	add	a,@r0
	mov	@r0,a
	jnc	L06B1
	inc	r0				; random number byte 2
	inc	@r0
	jmp	L06B1
;
	nop
	nop
	nop
	nop
	nop
;
;  This looks like another table - timer reload tables for different board rates perhaps ??
;
L0700:
;
	db	0FFH
	db	0FEH
	db	0FDH
	db	0FAH
	db	0F4H
	db	0E8H
	db	0D0H
	db	040H
	db	0FFH
	db	0FEH
	db	0FDH
	db	0FAH
	db	0F4H
	db	0E8H
	db	0D0H
	db	040H
;
;	mov	a,r7
;	mov	a,r6
;	mov	a,r5
;	mov	a,r2
;	call	L07E8
;	xrl	a,@r0
;	orl	a,@r0
;	mov	a,r7
;	mov	a,r6
;	mov	a,r5
;	mov	a,r2
;	call	L07E8
;	xrl	a,@r0
;	orl	a,@r0
;
;  We get here after doing keyboard stuff in the 600's
;
L0710:
	sel	rb1
	mov	a,r1				; buffer pointer
	jz	L0753				; empty?
	jb6	L0780				; bit 6 on?
	sel	rb0
	xrl	a,#006H
	mov	r1,a
	mov	a,r2
	jf1	L0727				; doing serial?
	jb5	L0727
	anl	a,#03FH
	sel	rb1
	mov	r3,#000H
	sel	rb0
	jmp	L074A
;
L0727:
	add	a,#040H
	mov	r2,a
	jnc	L0781
	sel	rb1
	mov	a,r2				; get baudrate
	movp	a,@a				; get timer value from table at L0700
	add	a,r3
	inc	r3
	jnc	L0780
	mov	r3,#000H
	sel	rb0
	mov	a,r2
	jb5	L074A
	jf0	L0747				; making sound?
	mov	a,@r1
	jb7	L0781
	inc	r1
	inc	r1
	call	L0388
	add	a,#0E5H
	jc	L0781
	mov	a,r2
L0747:
	orl	p2,#030H			; CTR / DTR high
	clr	f1				; not doing serial
L074A:
	xrl	a,#020H				; toggle bit 5 in R2
	mov	r2,a
	jb5	L0781
	call	Reset_state_mc
	jmp	Get_IPC_Stat_R7
;
L0753:
	mov	t,a
	mov	r3,a
	sel	rb0
	mov	a,r2
	jf0	L0783				; we doing sound?
	xrl	a,#004H				; toggle bit 2 in R2
	mov	r2,a
	sel	rb1
	anl	a,#004H				; bit 2 determines which serial port is being used
	orl	a,#010H				; add 10H to get address into R1
	mov	r1,a
	mov	a,@r1				; get baud rate and status into a
	jb7	L077E				; bit 7 on means serial port closed
	anl	a,#00FH				; mask off lower 4 bits (although baud only lowest 3)
	mov	r2,a				; setup R2' for the interrupt routines to determine baud rate
	inc	r1
	inc	r1				; bump r1 to point to buffer
	call	L0388				; gets entries in buffer (lowest 5 bits only)
	add	a,#0E5H
	jc	L077E				; some kind of overflow or near full test?
	inc	r1
	mov	a,r1				; get 13H or 17H
	cpl	f1				; toggle serial flag
	jb2	L0779				; other serial port
	anl	p2,#0EFH			; cts Low
	jmp	L077B
;
L0779:
	anl	p2,#0DFH			; dtr Low
L077B:
	en	i
	jmp	L0780
;
L077E:
	mov	r1,#000H
L0780:
	sel	rb0
L0781:
	jmp	Get_IPC_Stat_R7
;
L0783:
	jb1	L0788				; sound on?
	clr	f0				; clear flag - not doing sound
	jmp	Get_IPC_Stat_R7
;
L0788:
	anl	a,#0FDH
	mov	r2,a
	sel	rb1
	mov	r1,#040H
	mov	a,@r1
	dec	a
	mov	@r1,a
	inc	r1
	mov	a,@r1
	dec	a
	mov	@r1,a
	mov	r4,#086H			; will trigger sound call from timer interrupt
	en	tcnti
	mov	r0,#046H
	call	L0246
	sel	rb0
	jmp	Get_IPC_Stat_R7
;
; It's likey these movp commands use the table at L0700 - setting interrupt timer value?
; these seem to be used to 'tune' the timing loops for different baud rates...
;
L079F:
	mov	a,#003H
L07A1:
	dec	a
	jnz	L07A1
	movp	a,@a
L07A5:
	nop
L07A6:
	movp	a,@a
L07A7:
	ret
;
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
L07E8:
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
L07F0:
;
;  This code here is very odd - does not seem to be called from anywhere - so presumable some small data table or identity stamp?
; values are 02 14 00 - which curiously matches version 2 and subversion 20 (14 in hex)- so perhaps just the version number
;
	outl	bus,a
	call	L0000
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
